<?php
	if (isset($_POST['newspage_numitems']))
		update_option('newspage_numitems', $_POST['newspage_numitems']);
	if (isset($_POST['newspage_cache_on']))
		update_option('newspage_cache_on', $_POST['newspage_cache_on']);
	if (isset($_POST['newspage_cache_duration']))
		update_option('newspage_cache_duration', $_POST['newspage_cache_duration']);
	if (isset($_POST['newspage_cache_duration_units']))
		update_option('newspage_cache_duration_units', $_POST['newspage_cache_duration_units']);
	if (isset($_POST['newspage_linklove']))
		update_option('newspage_linklove', $_POST['newspage_linklove']);
	if (isset($_POST['newspage_useFeedTitle']))
		update_option('newspage_useFeedTitle', $_POST['newspage_useFeedTitle']);
	if (isset($_POST['newspage_showtopics']))
		update_option('newspage_showtopics', $_POST['newspage_showtopics']);
	$newspage_numitems = get_option('newspage_numitems');
	$newspage_cache_on = get_option('newspage_cache_on');
	$newspage_cache_duration = get_option('newspage_cache_duration');
	$newspage_cache_duration_units = get_option('newspage_cache_duration_units');
	$newspage_linklove = get_option("newspage_linklove");
	$newspage_useFeedTitle = get_option("newspage_useFeedTitle");
	$newspage_showtopics = get_option("newspage_showtopics");
?>
<style>
a.info{position:relative;z-index:24;}
a.info:hover {z-index:25;text-decoration:none;}
a.info span {display: none;}
a.info:hover span {display:block;position:absolute;top:1em;left:0;width:350px;border:1px solid #000;background-color:#ccc;color:#000;padding:4px;}
</style>
<div class="wrap">
	<h2>NewsPage Settings</h2>
	<form method="post" action="" id="ap_conf">
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label for="newspage_numitems">Number of Items to Show Per Feed?</label></th>
		<td><input type="text" name="newspage_numitems" value="<?=$newspage_numitems?>" /></td>
	</tr>
	<tr valign="top">
		<th scope="row"><label for="newspage_cache_on">Turn caching on?</label></th>
		<td>
			<select name="newspage_cache_on">
				<option value="1" <?php if($newspage_cache_on == 1) echo " selected "; ?>>Yes (Recommended)</option>
				<option value="0" <?php if($newspage_cache_on == 0) echo " selected "; ?>>No</option>
			</select>
			<p class="footnote">Disabling cache will negatively impact performance (and anger feed creators), but will ensure that the very freshest version of the feed is displayed at all times.</p></td>
		</td>
	</tr>
	<tr valign="top">
		<th scope="row"><label for="newspage_cache_duration">How long to cache for?</label></th>
		<td>
			<input type="text" class="text" name="newspage_cache_duration" value="<?php echo $newspage_cache_duration ?>" size="10" />
			<select name="newspage_cache_duration_units">
				<option value="1" <?php if($newspage_cache_duration_units == 1) echo " selected "; ?>>Seconds</option>
				<option value="60" <?php if($newspage_cache_duration_units == 60) echo " selected "; ?>>Minutes</option>
				<option value="3600" <?php if($newspage_cache_duration_units == 3600) echo " selected "; ?>>Hours</option>
				<option value="87840" <?php if($newspage_cache_duration_units == 87840) echo " selected "; ?>>Days</option>
			</select>
			<p class="footnote">How long before we ask the feed if it's been updated? Recommend 1 hour (3600 seconds).</p></td>
		</td>
	</tr>
	<tr valign="top">
	<td colspan=2>
		<label for="newspage_useFeedTitle"><input type="checkbox" name="newspage_useFeedTitle" id="newspage_useFeedTitle" value="1" 
		<?php if ($newspage_useFeedTitle == 1) echo ' checked="checked"'; ?>
		/>Use the titles from the RSS feeds for each feed? (not checking this option, will use the title you enter in RSS Feeds page).
		</label>
	</td>
	</tr>
	<tr valign="top">
	<td colspan=2>
		<label for="newspage_showtopics"><input type="checkbox" name="newspage_showtopics" id="newspage_showtopics" value="1" 
		<?php if ($newspage_showtopics == 1) echo ' checked="checked"'; ?>
		/>Show List of Topics at bottom of newspage
		</label>
	</td>
	</tr>
	<tr valign="top">
	<td colspan=2>
		<label for="newspage_linklove"><input type="checkbox" name="newspage_linklove" id="newspage_linklove" value="1" 
		<?php if ($newspage_linklove == 1) echo ' checked="checked"'; ?>
		/>Help promote newsPage plugin? <a href='#' class='info'>more&gt;<span>This option will add the code <code>newsPage brought to you by &lt;a href='http://www.rogerstringer.com/projects/newspage/'&gt;newsPage Plugin&lt;/a&gt;.</code>. Try turning it on, updating your options, and see the code in the code example to the right. These links and donations are greatly appreciated.</span></a>
		</label>
	</td>
	</tr>
	</table>
	<br />
	<input type="submit" value="Save Settings" class="button" />
	</form>
	<h2>Displaying your NewsPage on a page</h2>
	<p>
		To display your NewsPage on a page of your blog, create a page and
		add the following line to it anywhere:<br/>
		<div style="padding-left:20px;">
			&lt;!--newspage--&gt; or [newspage]
		</div>
	</p>
	<p>
		Or, alernatively, you can also add the following php code to a template on your blog:<br/>
		<div style="padding-left:20px;">
			&lt;?php if (function_exists('newsPage')) newsPage(); ?&gt;
		</div>
	</p>
	<p>
		If you want to limit how many feeds are displayed, like if you were displaying a couple on a frontpage, and the rest on another page, you could call it like this:
		<div style="padding-left:20px;">
			&lt;?php if (function_exists('newsPage')) newsPage(2); ?&gt;
		</div>
	</p>
	<p>
		To show a list of topics on a page, use the following code:
		<div style="padding-left:20px;">
			&lt;!--newstopics--&gt; or [newstopics]
		</div>
	</p>
	<p>
		Or, alernatively, you can also add the following php code to a template on your blog:<br/>
		<div style="padding-left:20px;">
			&lt;?php if (function_exists('newsTopics')) newsTopics(); ?&gt;
		</div>
	</p>
	<p>
		You can also directly specify a topic using your php function, by entering the follow:
		<div style="padding-left:20px;">
			&lt;?php if (function_exists('newsPage')) newsPage(5,"<b>web design</b>"); ?&gt;
		</div>
	</p>
	<p>
		This will tell the plugin to display your activity feed at that location.
	</p>
</div>